include TimedMsgBox.inc
include ..\CmnHdr.inc

;**********************CODE SEGMENT*********************************
.code

;************************************************
start:
invoke GetModuleHandle, NULL
mov hInstance, eax

chWindows9xNotAllowed

;How many seconds we'll give the user to respond
mov g_nSecLeft,10

;Create a multishot 1 second timer that begins firing after 1 second.
invoke CreateTimerQueueTimer,addr hTimerQTimer, NULL,offset MsgBoxTimeout, NULL,1000, 1000, 0

;Display the message box
invoke MessageBox,NULL, SADD("You have 10 seconds to respond"),ADDR g_szCaption, MB_OK

; Cancel the timer & delete the timer queue
INVOKE DeleteTimerQueueTimer,NULL, hTimerQTimer, NULL

;Let us know if the user responded or if we timed-out.
.if g_nSecLeft == 0
	invoke MessageBox,NULL,SADD("Timeout"), SADD("Result"), MB_OK
.ELSE
	INVOKE MessageBox,NULL,SADD("User responded"),SADD("Result"), MB_OK
.ENDIF

invoke ExitProcess,NULL

;**********MsgBoxTimeout FUNC*************************************
MsgBoxTimeout proc pvContext:dword,fTimeout:dword
local hwnd:HWND	
local sz[100]:byte
	;NOTE: Due to a thread race condition, it is possible (but very 
    ;unlikely)
    ;that the message box will not be created when we get here.
    invoke FindWindow,NULL,addr g_szCaption
	mov hwnd,eax
	
	.if eax
		;The window does exist; update the time remaining.
		invoke wsprintf,addr sz, SADD("You have %d seconds to respond"), g_nSecLeft			    
		DEC g_nSecLeft
		invoke SetDlgItemText,hwnd, ID_MSGBOX_STATIC_TEXT,addr sz
		
		.if g_nSecLeft == 0
			;The time is up; force the message box to exit.
			invoke EndDialog,hwnd, IDOK
		.endif
	.else
		;he window does not exist yet; do nothing this time.
        ; We'll try again in another second.
	.endif	  
	
	ret
MsgBoxTimeout endp
;************************************************

end start
